package si.mojeznanje.model;

public abstract class Zival {

    public static final Integer MOSKI = 0;
    public static final Integer ZENSKI = 1;

    private String ime;
    private Integer starost;
    private Integer spol;

    public Zival(){
        System.out.println("Nova zival je ustvarjena");
    }

    public Zival(String ime, Integer starost){
        this.ime = ime;
        this.starost = starost;
    }

    public String getIme() {
        return ime;
    }

    public void setIme(String ime) {

        if(ime == null)
            ime = "DEFAULT";

        if(ime == "")
            ime = "DEFAULT";

        this.ime = ime;
    }

    public Integer getStarost() {
        return starost;
    }

    public void setStarost(Integer starost) {

        if(starost < 0)
            starost = 0;

        this.starost = starost;
    }

    public Integer getSpol() {
        return spol;
    }

    public void setSpol(Integer spol) throws Exception {

        if(spol != MOSKI && spol != ZENSKI)
            throw new Exception("To ni validen spol!");

        this.spol = spol;
    }

    @Override
    public String toString() {
        return "ime: " + ime + " starost: " + starost + " spol : " + spol;
    }

    public Boolean equals(Zival zival){

        if(zival == null){
            return false;
        }

        if(!this.getClass().equals(zival.getClass())){
            return false;
        }

        return this.getIme().equals(zival.getIme()) && this.getStarost() == zival.getStarost() && this.getSpol() == zival.getSpol();
    }

    public abstract void oglasiSe();
}
